/*-------------------------Copyright Notice ---------------------------------
                 Copyright (c) 1996  NETBULA, LLC
                    All Rights Reserved

This generated text is a part of the source code of a computer software.
It contains proprietary information and trade secrets of NETBULA, LLC.
No part of this copyrighted work may be reproduced or disclosed by any
means without the prior written permission from the copyright owner.

No part of this source code nor its compiled form may be used in a commercial
software unless authorized by a license agreement between you and the copyright
owner, Netbula, LLC.

Netbula, LLC is not liable under any theory for any direct or indirect damage
resulted from using this generated source code.

For license information, please contact Netbula at:
Netbula, LLC  P.O. Box 99335 Emeryville CA 94662 USA
----------------------------------------------------------------------------*/
#ifndef DS_1_H
#define DS_1_H
#define PORTMAP
#include <rpc/rpc.h>
#include <malloc.h>
#include <stdio.h>
#include <string.h>
#define PRINTMSG  (unsigned long)(1)
#define DS_1  (unsigned long)(1)
#define DS  (unsigned long)(12820)
#ifndef POWERRPC_COMMON_H
#define POWERRPC_COMMON_H
#define ERR_NULL_CLNT -125
#define server_err(x) pwrpc_report_event(x)
#define MEM_ASSERT(P) {if(P==0){server_err("Memory exhausted!"); return 0;}}
#define server_msg(x) pwrpc_report_event(x)
#define server_exit(x) exit(x)
#endif


#ifdef POWERRPC_XDR

typedef struct printmsg_in_t{
	char*	msg;
}printmsg_in_t;

bool_t xdr_printmsg_in_t(XDR*, struct printmsg_in_t*);

#endif


#ifdef POWERRPC_CLIENT

int	printmsg_wrap(CLIENT* pclnt, struct timeval* ptimeout, struct printmsg_in_t* pIn);
#define DS_1_HANDLE DS_1_handle
#define DS_1_TIMEOUT DS_1_timeout

#endif


#ifdef POWERRPC_SERVER

void	printmsg_call(struct printmsg_in_t* pIn);
void ds_1(struct svc_req* rqstp,SVCXPRT* txp);

#endif


#ifndef DSAPI
#if (defined(_WIN32)||defined(WIN32)) && _DLL
#define DSAPI  __declspec(dllexport)
#else
#define DSAPI
#endif
#endif
DSAPI void	printmsg(char*	msg);

DSAPI CLIENT*	ds_bind(const char* host, u_long prog, u_long ver,char* proto);
DSAPI void	ds_unbind(CLIENT* pclnt);
DSAPI void	ds_bind_handle(CLIENT* pclnt);
DSAPI enum clnt_stat	ds_errno(CLIENT* pclnt);

DSAPI SVCXPRT*	ds_1_reg(int sock, unsigned long prog_no, unsigned long ver, int proto);
DSAPI void	ds_1_unmap(unsigned long prog_no, unsigned long ver);
DSAPI void	ds_1_main(int argc, char ** argv);

#include <powerrpc.h>
#endif
