/*-------------------------Copyright Notice ---------------------------------
                 Copyright (c) 1996  NETBULA, LLC
                    All Rights Reserved

This generated text is a part of the source code of a computer software.
It contains proprietary information and trade secrets of NETBULA, LLC.
No part of this copyrighted work may be reproduced or disclosed by any
means without the prior written permission from the copyright owner.

No part of this source code nor its compiled form may be used in a commercial
software unless authorized by a license agreement between you and the copyright
owner, Netbula, LLC.

Netbula, LLC is not liable under any theory for any direct or indirect damage
resulted from using this generated source code.

For license information, please contact Netbula at:
Netbula, LLC  P.O. Box 99335 Emeryville CA 94662 USA
----------------------------------------------------------------------------*/
#define POWERRPC_XDR
#define POWERRPC_CLIENT
#include "ds.h"
static char *version_str="@(#)powerRPC V1.1 MxTF! system: WIN32";
;
CLIENT* DS_1_handle = 0;
struct timeval DS_1_timeout = {60, 0};
int	printmsg_wrap(CLIENT* pclnt, struct timeval* ptimeout, struct printmsg_in_t* pIn){
	int ret_code;
	if(pclnt==(CLIENT*)0) {
		return ERR_NULL_CLNT;
	}
	ret_code = clnt_call(pclnt,
	                     PRINTMSG,
	                     (xdrproc_t)xdr_printmsg_in_t,
	                     (void*)pIn,
	                     (xdrproc_t)xdr_void,
	                     (void*)0,
	                     *ptimeout
	                    );

	if(ret_code != RPC_SUCCESS) {
		clnt_perror(pclnt,"printmsg");
	}
	return ret_code;
}

void	printmsg(char*	msg){
	printmsg_in_t	Input;

	struct timeval timeOut;
	Input.msg = msg;

	timeOut = DS_1_TIMEOUT;
	printmsg_wrap(DS_1_HANDLE, &timeOut, &Input);

}

CLIENT*	ds_bind(const char* host, u_long prog, u_long ver,char* proto) {
	char * protoc = "tcp";
	ver = (ver==0? DS_1 : ver);
	prog = (prog==0? DS : prog );
	protoc = (proto==(char*)0? protoc : proto);
	DS_1_handle = pw_clnt_create(host, 3456, prog, ver, protoc, 0, 0);
	return DS_1_handle;
}

void	ds_bind_handle(CLIENT* pclnt){
	DS_1_handle = pclnt;
}

void	ds_unbind(CLIENT* pclnt) {
	pclnt  = (pclnt==0? DS_1_handle: pclnt);
	if(pclnt)
		clnt_destroy(pclnt);
}

enum clnt_stat	ds_errno(CLIENT* pclnt) {
	return pw_clnt_errno(pclnt?pclnt:DS_1_HANDLE);
}

